subroutine read_binput_394(binput)

  use params
  use binput_parse_4_0
  use retvparam
  use bandparam
  use lineparam
  use solar
  use channel
  use initialize
  use opt
  use writeout

  implicit none

  logical :: sfix

! --- obsolete - read them here but do not write to new sfit4.ctl

                                                ! in calculation other than those
                                                ! fit, if 0 include all found
   integer, parameter :: maxinc = 10            ! max number of gases to include
                                                ! in background
   integer, parameter :: maxmolsub = 15         ! max molecular mass
   real(double), dimension(maxinc) :: sclinc    ! initial profile scale for
                                                ! background gases
   character, dimension(maxinc) :: gasinc*7     ! names of gases to include
   real(double), dimension(2,maxmolsub) :: pline
   integer :: nginc = 0, iphase=0, iifdiff

! --- these are used
  character (len=*) :: binput

  character (len=255) :: tmpstr
  character(len=255), dimension(255,255) :: atdata
  !integer dontknow
  integer i, nr, nr1, nr2, iostat
  integer tmpint
  integer irtype(100)

  real minb(20,20), maxb(20,20)
  integer nspecfile(20)

  real(double) :: tchan_scale, tschan_scale

   INTEGER                         :: IRTEPHS, IRTEAP

  open(10,file=binput, status='old')

  ! detail
  read(10, '(a)') tfile(16)
  ! pbpfile
  read(10, '(a)') tfile(08)
  ! sol_linelist
  read(10, '(a)') tfile(11)
  ! statevec
  read(10, '(a)') tfile(18)
  read(10, '(a)') tfile(23)
  read(10, '(a)') tfile(24)
  ! sa_input
  read(10, '(a)') tfile(62)
  ! iso_input
  read(10, '(a)') tfile(21)
  ! summary
  read(10, '(a)') tfile(20)
  read(10, '(a)') lindir

  read(10, '(2i5)') nret, isoflag
  useiso = .false.
  if (isoflag.gt.0) useiso=.true.
  do nr = 1,nret
     read(10, '(a7)') gas(nr)
     read(10, '(2i5,3f10.0,i5)') irtype(nr), ifoff(nr), zwid(nr), zgmin(nr), zgmax(nr), ilogretrieval(nr)
     if (ilogretrieval(nr).eq.1) then
        log_statev(nr) = .true.
     else
        log_statev(nr) = .false.
     end if
     if (irtype(nr).gt.1) then
        nlayers = irtype(nr)
        ifprf(nr) = .true.
        read(10, *) (sig(i,nr),i=1,irtype(nr))
     else
        ifprf(nr) = .false.
        read(10, *) colsf(nr), scolsf(nr)
     end if


  end do

  read(10, '(2f10.0,i5)') delnu, dn(1), lshapemodel

  read(10, '(2i5)') itrmax, ipflag

  if (ipflag.eq.1) then
     read(10,'(a)') tmpstr
     read(tmpstr, '(15f5.0)') (pline(1,nr), nr=1,15)
     read(10,'(a)') tmpstr
     read(tmpstr, '(15f5.0)') (pline(2,nr), nr=1,15)
  end if



  read(10,'(a)') tmpstr
  read(tmpstr,*,IOSTAT=iostat) wavfac(1), pmax(1), omega(1), &
       & iap(1), nband, ifps, &
       & ieap, neap, iephs, nephs, iemission
  if(iostat.lt.0) then
     read(tmpstr, *, IOSTAT=iostat) wavfac(1), pmax(1), omega(1), iap(1), &
          nband, ifps, ieap, neap, iephs, nephs
  end if

  fps = .false.
  if (ifps.ne.0) fps=.true.


  if (iemission.gt.0) then
     emission = .TRUE.
     read(10,*) emission_t_back, emission_object, ienorm(1)
     emission_norm = .false.
     if (ienorm(1).eq.1) then
        emission_norm = .true.
     else
        emission_norm = .false.
     end if
  else
     emission = .FALSE.
  end if

  read(10,'(a)') tmpstr
  read(tmpstr,*,IOSTAT=iostat) isparm, nback, tmpint, iifdiff, &
       & iphase, irteap, irtephs, ilevenberg
  if(iostat.lt.0) then
     ilevenberg=0
     read(tmpstr,*,IOSTAT=iostat) isparm, nback, tmpint, iifdiff, &
          & iphase, irteap, irtephs
  end if
  if( iphase .eq. 1 ) ifphase = .TRUE.
  if (tmpint == 0) then
     ifco = .false.
  else
     ifco = .true.
  end if

  if (ilevenberg.gt.0) then
     lm = .true.
     read(10,*) gamma_start, gamma_dec, gamma_inc, &
          & stop_criterion
  else
     lm = .false.
  end if

  read(10,*) wshft, swshft, bcksl, sbcksl, &
       & bckcrv, sbckcrv, copar, scopar, &
       & phs, sphs, szero(1), eappar, seappar, &
       & ephspar, sephspar, tchan_scale, tschan_scale

  if (ifco) then

     read(10,*) cparm(4)
     read(10,*) tmpint
     if(tmpint .eq. 1 )f_rtsol(4) =.true.
     if (f_rtsol(4)) then
        sfix = .true.
     else
        sfix = .false.
     end if
  end if

  szero(1:nband) = szero(1)

  do nr = 1,nband
     read(10,*) wave3(nr), wave4(nr), nretb(nr), zshift(nr,1), &
          izero(nr), nbeam_of_band(nr), channel_model_of_band(nr)
     do nr1 = 1,nbeam_of_band(nr)
        read(10,*) cciparm(nr,nr1,1:4)
        read(10,*) channel_ifix(nr,nr1,1:4)
        chan_scale(nr,nr1,1:4) = tchan_scale
        schan_scale(nr,nr1,1:4) = tschan_scale
     end do

     do nr1 = 1,nretb(nr)
        read(10,*) gasb(nr,nr1), minb(nr,nr1), maxb(nr,nr1)
     end do

  end do

  if( nband .gt. 1 ) then
     dn(2:nband) = dn(1)
     pmax(2:nband) = pmax(1)
     wavfac(2:nband) = wavfac(1)
     iap(2:nband) = iap(1)
     omega(2:nband) = omega(1)
  endif

  read(10,*) nspec, snr, tol, nginc
  do nr = 1,nginc
     read (10,*) gasinc(nr), sclinc(nr)
  end do
  do nr = 1,nspec
     read(10,*) ispec(nr), nspecfile(nr)
     do nr2 = 1,nspecfile(nr)
        read (10,'(a)') atdata(nr,nr2)
     end do
  end do

  read (10,*) nstnr
  if (nstnr.gt.0) then
     do nr = 1,nstnr
        read(10,*) wwv0(nr), wwv1(nr), gstnr(nr)
     end do
  end if


end subroutine read_binput_394


subroutine read_rdrv_394(rdrv_393, binput_393)

  use initialize
  use writeout


implicit none
character (len=*), intent(in)  :: rdrv_393
character (len=*), intent(out) :: binput_393

!character (len=255) :: tmp_str

integer :: iostat
!integer  iretflg

print *, trim(rdrv_393)
open(unit=11,file=trim(rdrv_393), status='old')


read(11, '(a)') binput_393
read(11, '(a)') tfile(09) ! ptfile
read(11, '(a)') tfile(07) ! masspath file
read(11, '(a)') tfile(12) ! mixfile
read(11, '(a)') tfile(15) ! spectrum
read(11, *) retflg
if (.not.retflg) then
   read(11,*) tfile(19)
end if
read(11, *) f_wrtk
if (f_wrtk) then
   read(11,*) tfile(66)
end if
read(11,*,IOSTAT=iostat), f_wrtsa
if (iostat.ge.0) then
   f_wrtsa=.false.
   close(11)
   return
end if
if (f_wrtsa) then
   read(11,*) tfile(61)
end if
read(11,*,IOSTAT=iostat), f_wrtgasspc
if (iostat.ge.0) then
   if (f_wrtgasspc) then
      read(11,*) gasouttype
   end if
   read (11,*,IOSTAT=iostat) uflag, ugas, uval
else
   close(11)
   return
end if
   close(11)
end subroutine read_rdrv_394

